unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TMainForm = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    HookTypes: TRadioGroup;
    Panel2: TPanel;
    BtnInstall: TBitBtn;
    BtnUnInstall: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnInstallClick(Sender: TObject);
    procedure BtnUnInstallClick(Sender: TObject);
  private
    WndProc: TWndMethod;
    procedure CustomWndProc(var Msg: TMessage);

    procedure HookedCallWndProc(const Msg: TMessage);
    procedure HookedCallWndRetProc(const Msg: TMessage);
    procedure HookedCBTProc(const Msg: TMessage);
    procedure HookedDebugProc(const Msg: TMessage);
    procedure HookedForegroundIdleProc(const Msg: TMessage);
    procedure HookedGetMsgProc(const Msg: TMessage);
    procedure HookedJournalPlaybackProc(const Msg: TMessage);
    procedure HookedJournalRecordProc(const Msg: TMessage);
    procedure HookedLowLevelKeyboardProc(const Msg: TMessage);
    procedure HookedKeyboardProc(const Msg: TMessage);
    procedure HookedLowLevelMouseProc(const Msg: TMessage);
    procedure HookedMouseProc(const Msg: TMessage);
    procedure HookedMessageProc(const Msg: TMessage);
    procedure HookedSysMsgProc(const Msg: TMessage);
    procedure HookedShellProc(const Msg: TMessage);

    procedure MessageOut(AMsg: string; const Msg: TMessage);
    procedure InitControls();
    procedure UiEnable(AInstallMode: Boolean);
  public

  end;

var
  MainForm: TMainForm;

implementation

uses
    iHookTypes;                        

{$R *.dfm}

(******************************************************************************)

(*
    ===========================================================================
    DLLC|[gEăX^eBbNN
    ===========================================================================
*)
function    HookInstall(Wnd: HWND; HookType: THookType): Boolean; stdcall;external HOOK_DLL_NAME;
procedure   HookUnInstall(HookType: THookType); stdcall;external HOOK_DLL_NAME;
procedure   HookUnInstallFull(); stdcall;external HOOK_DLL_NAME;

(******************************************************************************)

(*
    ===========================================================================
    ȉ
    ===========================================================================
*)
procedure TMainForm.InitControls();
var
    i: THookType;
begin
    for i := Low(THookType) to High(THookType) do
    begin
        HookTypes.Items.AddObject(HookTypeStr[i], TObject(i));
    end;
end;

(*
    ===========================================================================
    i̗L/؂ւ
    ===========================================================================
*)
procedure TMainForm.UiEnable(AInstallMode: Boolean);
begin
    BtnInstall.Enabled := AInstallMode;
    HookTypes.Enabled := AInstallMode;
    BtnUnInstall.Enabled := not AInstallMode;
end;

(*
    ===========================================================================
    bZ[W\
    ===========================================================================
*)
procedure TMainForm.MessageOut(AMsg: string; const Msg: TMessage);
var
    NowStr: string;
    FmtStr: string;
begin
    NowStr := FormatDateTime('yyyy/mm/dd hh:nn:ss', Now);
    FmtStr := Format('%s %s lParam:%d,wParam:%d', [NowStr, AMsg, Msg.lParam, Msg.wParam]);
    Memo1.Lines.Add(FmtStr);

    //  http://forum.nifty.com/fdelphi/samples/00782.html
    //  I̎dg
    if (GetAsyncKeyState(VK_ESCAPE)) <> 0 then BtnUnInstallClick(BtnUnInstall);

    //  100sł߂B
    if (Memo1.Lines.Count >= 100) then BtnUnInstallClick(BtnUnInstall);
end;

(******************************************************************************)

(*
    ===========================================================================
    CXg[
    ---------------------------------------------------------------------------
    |̂œ1!!!!!!!
    ===========================================================================
*)
procedure TMainForm.BtnInstallClick(Sender: TObject);
var
    Index: integer;
    Selected: THookType;
begin
    //  ȂɂIĂ܂H
    Index := HookTypes.ItemIndex;
    if (Index = -1) then Exit;
    Selected := THookType(HookTypes.Items.Objects[Index]);

    //  ͂΂
    if (Selected = htJournalPlaybackProc) then
    begin
        ShowMessage('̃TṽtbN̕@Ƃ͂΂B߂ƂāB');
        Exit;
    end;

    //  x
    ShowMessage('bZ[W100s܂珟ɃtbN𒆎~܂B'#13#10'x^XN}l[WŎ~߂Ƃ...');
    //  NA
    Memo1.Clear;

    //  SACXg[
    HookUnInstallFull();
    //  CXg[
    HookInstall(Self.Handle, Selected);
    //  쐧
    UiEnable(false);
end;

(*
    ===========================================================================
    ACXg[
    ===========================================================================
*)
procedure TMainForm.BtnUnInstallClick(Sender: TObject);
begin
    //  SACXg[
    HookUnInstallFull();
    //  쐧
    UiEnable(true);
end;

(******************************************************************************)

(*
    ===========================================================================
    tH[RXgN^
    ===========================================================================
*)
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  ȉ
    InitControls();
    //  EBhEvV[WobNAbv
    WndProc := Self.WindowProc;
    //  ւ
    Self.WindowProc := CustomWndProc;
end;

(*
    ===========================================================================
    tH[fXgN^
    ===========================================================================
*)
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  tbN֐ACXg[
    HookUnInstallFull();
    //  łEBhEvV[W߂
    Self.WindowProc := WndProc;
end;

(*
    ===========================================================================
    ւpEBhEvV[W
    ===========================================================================
*)
procedure TMainForm.CustomWndProc(var Msg: TMessage);
begin

    //  ǂȂtbNH
    case Msg.Msg of

    //  CallWndProc
    UM_CallWndProc_BEGIN..UM_CallWndProc_END:
        HookedCallWndProc(Msg);

    //  CallWndRetProc
    UM_CallWndRetProc_BEGIN..UM_CallWndRetProc_END:
        HookedCallWndRetProc(Msg);

    //  CBTProc
    UM_CBTProc_BEGIN..UM_CBTProc_END:
        HookedCBTProc(Msg);

    //  DebugProc
    UM_DebugProc_BEGIN..UM_DebugProc_END:
        HookedDebugProc(Msg);

    //  ForegroundIdleProc
    UM_ForegroundIdleProc_BEGIN..UM_ForegroundIdleProc_END:
        HookedForegroundIdleProc(Msg);

    //  GetMsgProc
    UM_GetMsgProc_BEGIN..UM_GetMsgProc_END:
        HookedGetMsgProc(Msg);

    //  JournalPlaybackProc
    UM_JournalPlaybackProc_BEGIN..UM_JournalPlaybackProc_END:
        HookedJournalPlaybackProc(Msg);

    //  UM_JournalRecordProc
    UM_JournalRecordProc_BEGIN..UM_JournalRecordProc_END:
        HookedJournalRecordProc(Msg);

    //  KeyboardProc
    UM_KeyboardProc_BEGIN..UM_KeyboardProc_END:
        HookedKeyboardProc(Msg);

    //  LowLevelKeyboardProc
    UM_LowLevelKeyboardProc_BEGIN..UM_LowLevelKeyboardProc_END:
        HookedLowLevelKeyboardProc(Msg);

    //  MouseProc
    UM_MouseProc_BEGIN..UM_MouseProc_END:
        HookedMouseProc(Msg);

    //  LowLevelMouseProc
    UM_LowLevelMouseProc_BEGIN..UM_LowLevelMouseProc_END:
        HookedLowLevelMouseProc(Msg);

    //  MessageProc
    UM_MessageProc_BEGIN..UM_MessageProc_END:
        HookedMessageProc(Msg);

    //  ShellProc
    UM_ShellProc_BEGIN..UM_ShellProc_END:
        HookedShellProc(Msg);

    //  SysMsgProc
    UM_SysMsgProc_BEGIN..UM_SysMsgProc_END:
        HookedSysMsgProc(Msg);

    end;

    //  낤Ƃ͌ĂԁB
    WndProc(Msg);
end;

(******************************************************************************)

(*
    ===========================================================================
    HookedCallWndProc
    ===========================================================================
*)
procedure TMainForm.HookedCallWndProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_CallWndProc_HC_ACTION:
            MessageOut('UM_CallWndProc_HC_ACTION', Msg);

    end;
end;

(*
    ===========================================================================
    HookedCallWndRetProc
    ===========================================================================
*)
procedure TMainForm.HookedCallWndRetProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_CallWndRetProc_HC_ACTION:
            MessageOut('UM_CallWndRetProc_HC_ACTION', Msg);

    end;
end;

(*
    ===========================================================================
    HookedCBTProc
    ===========================================================================
*)
procedure TMainForm.HookedCBTProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_CBTProc_HCBT_ACTIVATE:
            MessageOut('UM_CBTProc_HCBT_ACTIVATE', Msg);
        UM_CBTProc_HCBT_CLICKSKIPPED:
            MessageOut('UM_CBTProc_HCBT_CLICKSKIPPED', Msg);
        UM_CBTProc_HCBT_CREATEWND:
            MessageOut('UM_CBTProc_HCBT_CREATEWND', Msg);
        UM_CBTProc_HCBT_DESTROYWND:
            MessageOut('UM_CBTProc_HCBT_DESTROYWND', Msg);
        UM_CBTProc_HCBT_KEYSKIPPED:
            MessageOut('UM_CBTProc_HCBT_KEYSKIPPED', Msg);
        UM_CBTProc_HCBT_MINMAX:
            MessageOut('UM_CBTProc_HCBT_MINMAX', Msg);
        UM_CBTProc_HCBT_MOVESIZE:
            MessageOut('UM_CBTProc_HCBT_MOVESIZE', Msg);
        UM_CBTProc_HCBT_QS:
            MessageOut('UM_CBTProc_HCBT_QS', Msg);
        UM_CBTProc_HCBT_SETFOCUS:
            MessageOut('UM_CBTProc_HCBT_SETFOCUS', Msg);
        UM_CBTProc_HCBT_SYSCOMMAND:
            MessageOut('UM_CBTProc_HCBT_SYSCOMMAND', Msg);

    end;
end;

(*
    ===========================================================================
    HookedDebugProc
    ===========================================================================
*)
procedure TMainForm.HookedDebugProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_DebugProc_HC_ACTION:
            MessageOut('UM_DebugProc_HC_ACTION', Msg);

    end;
end;

(*
    ===========================================================================
    HookedForegroundIdleProc
    ===========================================================================
*)
procedure TMainForm.HookedForegroundIdleProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_ForegroundIdleProc_HC_ACTION:
            MessageOut('UM_ForegroundIdleProc_HC_ACTION', Msg);

    end;
end;

(*
    ===========================================================================
    HookedGetMsgProc
    ===========================================================================
*)
procedure TMainForm.HookedGetMsgProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_GetMsgProc_HC_ACTION:
            MessageOut('UM_GetMsgProc_HC_ACTION', Msg);

    end;
end;

(*
    ===========================================================================
    HookedJournalPlaybackProc
    ===========================================================================
*)
procedure TMainForm.HookedJournalPlaybackProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_JournalPlaybackProc_HC_GETNEXT:
            MessageOut('UM_JournalPlaybackProc_HC_GETNEXT', Msg);
        UM_JournalPlaybackProc_HC_NOREMOVE:
            MessageOut('UM_JournalPlaybackProc_HC_NOREMOVE', Msg);
        UM_JournalPlaybackProc_HC_SKIP:
            MessageOut('UM_JournalPlaybackProc_HC_SKIP', Msg);
        UM_JournalPlaybackProc_HC_SYSMODALOFF:
            MessageOut('UM_JournalPlaybackProc_HC_SYSMODALOFF', Msg);
        UM_JournalPlaybackProc_HC_SYSMODALON:
            MessageOut('UM_JournalPlaybackProc_HC_SYSMODALON', Msg);

    end;
end;

(*
    ===========================================================================
    HookedJournalRecordProc
    ===========================================================================
*)
procedure TMainForm.HookedJournalRecordProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_JournalRecordProc_HC_ACTION:
            MessageOut('UM_JournalRecordProc_HC_ACTION', Msg);
        UM_JournalRecordProc_HC_SYSMODALOFF:
            MessageOut('UM_JournalRecordProc_HC_SYSMODALOFF', Msg);
        UM_JournalRecordProc_HC_SYSMODALON:
            MessageOut('UM_JournalRecordProc_HC_SYSMODALON', Msg);

    end;
end;

(*
    ===========================================================================
    HookedKeyboardProc
    ===========================================================================
*)
procedure TMainForm.HookedKeyboardProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_KeyboardProc_HC_ACTION:
            MessageOut('UM_KeyboardProc_HC_ACTION', Msg);
        UM_KeyboardProc_HC_NOREMOVE:
            MessageOut('UM_KeyboardProc_HC_NOREMOVE', Msg);

    end;
end;

(*
    ===========================================================================
    HookedLowLevelKeyboardProc
    ===========================================================================
*)
procedure TMainForm.HookedLowLevelKeyboardProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_LowLevelKeyboardProc_HC_ACTION:
            MessageOut('UM_LowLevelKeyboardProc_HC_ACTION', Msg);

    end;
end;

(*
    ===========================================================================
    HookedMouseProc
    ===========================================================================
*)
procedure TMainForm.HookedMouseProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_MouseProc_HC_ACTION:
            MessageOut('UM_MouseProc_HC_ACTION', Msg);
        UM_MouseProc_HC_NOREMOVE:
            MessageOut('UM_MouseProc_HC_NOREMOVE', Msg);

    end;
end;

(*
    ===========================================================================
    HookedLowLevelMouseProc
    ===========================================================================
*)
procedure TMainForm.HookedLowLevelMouseProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_LowLevelMouseProc_HC_ACTION:
            MessageOut('UM_LowLevelMouseProc_HC_ACTION', Msg);

    end;
end;

(*
    ===========================================================================
    HookedMessageProc
    ===========================================================================
*)
procedure TMainForm.HookedMessageProc(const Msg: TMessage);
begin
    case Msg.Msg of
        UM_MessageProc_MSGF_DDEMGR:
            MessageOut('UM_MessageProc_MSGF_DDEMGR', Msg);
        UM_MessageProc_MSGF_DIALOGBOX:
            MessageOut('UM_MessageProc_MSGF_DIALOGBOX', Msg);
        UM_MessageProc_MSGF_MENU:
            MessageOut('UM_MessageProc_MSGF_MENU', Msg);
        UM_MessageProc_MSGF_SCROLLBAR:
            MessageOut('UM_MessageProc_MSGF_SCROLLBAR', Msg);

    end;
end;

(*
    ===========================================================================
    HookedShellProc
    ===========================================================================
*)
procedure TMainForm.HookedShellProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_ShellProc_HSHELL_ACCESSIBILITYSTATE:
            MessageOut('UM_ShellProc_HSHELL_ACCESSIBILITYSTATE', Msg);
        UM_ShellProc_HSHELL_ACTIVATESHELLWINDOW:
            MessageOut('UM_ShellProc_HSHELL_ACTIVATESHELLWINDOW', Msg);
        UM_ShellProc_HSHELL_APPCOMMAND:
            MessageOut('UM_ShellProc_HSHELL_APPCOMMAND', Msg);
        UM_ShellProc_HSHELL_GETMINRECT:
            MessageOut('UM_ShellProc_HSHELL_GETMINRECT', Msg);
        UM_ShellProc_HSHELL_LANGUAGE:
            MessageOut('UM_ShellProc_HSHELL_LANGUAGE', Msg);
        UM_ShellProc_HSHELL_REDRAW:
            MessageOut('UM_ShellProc_HSHELL_REDRAW', Msg);
        UM_ShellProc_HSHELL_TASKMAN:
            MessageOut('UM_ShellProc_HSHELL_TASKMAN', Msg);
        UM_ShellProc_HSHELL_WINDOWACTIVATED:
            MessageOut('UM_ShellProc_HSHELL_WINDOWACTIVATED', Msg);
        UM_ShellProc_HSHELL_WINDOWCREATED:
            MessageOut('UM_ShellProc_HSHELL_WINDOWCREATED', Msg);
        UM_ShellProc_HSHELL_WINDOWDESTROYED:
            MessageOut('UM_ShellProc_HSHELL_WINDOWDESTROYED', Msg);
        UM_ShellProc_HSHELL_WINDOWREPLACED:
            MessageOut('UM_ShellProc_HSHELL_WINDOWREPLACED', Msg);

    end;
end;

(*
    ===========================================================================
    HookedSysMsgProc
    ===========================================================================
*)
procedure TMainForm.HookedSysMsgProc(const Msg: TMessage);
begin
    case Msg.Msg of

        UM_SysMsgProc_MSGF_DIALOGBOX:
            MessageOut('UM_SysMsgProc_MSGF_DIALOGBOX', Msg);
        UM_SysMsgProc_MSGF_MENU:
            MessageOut('UM_SysMsgProc_MSGF_MENU', Msg);
        UM_SysMsgProc_MSGF_SCROLLBAR:
            MessageOut('UM_SysMsgProc_MSGF_SCROLLBAR', Msg);

    end;
end;

end.

